using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using PrimeraTechnology.PTRobot;

namespace PTRobotUserControl
{
    class ThreadSettings
    {
        public uint nRobotID = 0;
        public uint[] nDriveArray = new uint[10];
        public string sPrintFile = null;
        public uint nCopies = 0;
        public uint nToLocation = 0;
        public uint nFromLocation = 0;
        public bool fUseRecorders = false;
        public bool fUsePrinter = false;
        public string sMergeData1 = "";
        public string sMergeData2 = "";
        public string sMergeData3 = "";
        public string sMergeData4 = "";
        public string sMergeData5 = "";
        public PTRobot_DLL myPTRobot;
    }
    
    class MovementsThread
    {
        public MovementsThread( ThreadSettings myThreadSettings )
        {
            m_ThreadSettings = new ThreadSettings();
            m_ThreadSettings = myThreadSettings;
        }

        
        public void DoMovements()
        {
            
            //m_ThreadSettings.PTRobotDLL.PrintFile(m_ThreadSettings.nRobotID,
            //                                      m_ThreadSettings.sPrintFile, 0);

            m_ThreadSettings.myPTRobot.LoadDrive(m_ThreadSettings.nRobotID,
                                                    m_ThreadSettings.nDriveArray[0], DiscLocation.Auto, ClearDrive.Yes);

            WaitForCommand( m_ThreadSettings.nRobotID );

        }


        private PTRobotReturn WaitForCommand(uint nRobotID)
        {
            uint nValue = 0;
            PTRobotReturn retVal = PTRobotReturn.Ok;
            RobotStatus myRobotStatus = new RobotStatus();

            while (true)
            {
                retVal = m_ThreadSettings.myPTRobot.GetRobotStatus(nRobotID,
                                                                    ref myRobotStatus);
                if (PTRobotReturn.Ok == retVal)
                {
                    if (myRobotStatus.SystemState == SystemState.Idle)
                        break;
                    else if (myRobotStatus.SystemState == SystemState.Error)
                    {
                        
                    }
                }
                Thread.Sleep(500);


            }
            return retVal;
        }
        
        
        private ThreadSettings m_ThreadSettings;
    }
}
